Bug 1649573 - Review Request: directory-maven-plugin - Establish locations for files in multi-module builds
Summary: Review Request: directory-maven-plugin - Establish locations for files in mul...
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Severin Gehwolf
QA Contact: Fedora Extras Quality Assurance
URL: https://github.com/jdcasey/directory-...
Whiteboard:
Depends On:
Blocks: 1649552
TreeView+ depends on / blocked
 
Reported: 2018-11-13 22:00 UTC by Salman Siddiqui
Modified: 2018-11-22 14:51 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-11-21 22:04:04 UTC
jerboaa: fedora-review+


Attachments (Terms of Use)
rpmlint - SPEC (58 bytes, text/plain)
2018-11-13 22:03 UTC, Salman Siddiqui
no flags Details
rpmlint - SRPM (113 bytes, text/plain)
2018-11-13 22:03 UTC, Salman Siddiqui
no flags Details
rpmlint - RPM (116 bytes, text/plain)
2018-11-13 22:03 UTC, Salman Siddiqui
no flags Details

Description Salman Siddiqui 2018-11-13 22:00:45 UTC
Spec URL: https://pagure.io/jmc-rpm/blob/master/f/directory-maven-plugin/directory-maven-plugin.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/sasiddiq/jmc/fedora-29-x86_64/00823521-directory-maven-plugin/directory-maven-plugin-0.3.1-1.fc29.src.rpm

Description: Just submitted my first package. I am seeking a sponsor.
The Directory Plugin for Maven is used to discover various project-related paths,
such as the execution root directory, the directory for a specific project in the
current build session, or the highest project basedir (closed to the filesystem
root directory) available in the projects loaded from disk (not resolved from a
remote repository). The plugin will then reflect this value to the console, and
also inject it into each project's properties using the value of the property
plugin parameter.

Fedora Account System Username: sasiddiq
Successful Copr Build: https://copr.fedorainfracloud.org/coprs/sasiddiq/jmc/build/823521/

Comment 1 Salman Siddiqui 2018-11-13 22:03:00 UTC
Created attachment 1505457 [details]
rpmlint - SPEC

Comment 2 Salman Siddiqui 2018-11-13 22:03:12 UTC
Created attachment 1505458 [details]
rpmlint - SRPM

Comment 3 Salman Siddiqui 2018-11-13 22:03:30 UTC
Created attachment 1505459 [details]
rpmlint - RPM

Comment 4 Severin Gehwolf 2018-11-14 15:13:35 UTC
I'll review this one.

Comment 5 Severin Gehwolf 2018-11-15 15:02:04 UTC
(In reply to Salman Siddiqui from comment #0)
> Spec URL:
> https://pagure.io/jmc-rpm/blob/master/f/directory-maven-plugin/directory-
> maven-plugin.spec
> SRPM URL:
> https://copr-be.cloud.fedoraproject.org/results/sasiddiq/jmc/fedora-29-
> x86_64/00823521-directory-maven-plugin/directory-maven-plugin-0.3.1-1.fc29.
> src.rpm

Please use raw URLs for the Spec. This should work:
https://pagure.io/jmc-rpm/raw/master/f/directory-maven-plugin/directory-maven-plugin.spec

I'm getting 404 for the SRPM. Please put it somewhere more permanent. fedorapeople web-space should work for this. Thanks!

Comment 6 Severin Gehwolf 2018-11-15 15:49:17 UTC
From the spec:

BuildRequires:  javapackages-tools
BuildRequires:  maven-local
BuildRequires:  maven-parent
BuildRequires:  maven-plugin-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  sonatype-oss-parent

Please use mvn()-style BR's whenever possible:
$ dnf -q repoquery --provides maven-plugin-plugin | grep 'mvn('
mvn(org.apache.maven.plugins:maven-plugin-plugin) = 3.5.1
mvn(org.apache.maven.plugins:maven-plugin-plugin:pom:) = 3.5.1

That's a more accurate reflection of what's in the poms. But taking a closer look at the upstream pom I see these deps:

    <dependency>
      <groupId>junit</groupId>
      <artifactId>junit</artifactId>
      <version>4.8.2</version>
      <scope>test</scope>
    </dependency>
    <dependency>
      <groupId>org.apache.maven</groupId>
      <artifactId>maven-core</artifactId>
    </dependency>
    <dependency>
      <groupId>org.apache.maven</groupId>
      <artifactId>maven-plugin-api</artifactId>
    </dependency>
    <dependency>
      <groupId>org.apache.maven</groupId>
      <artifactId>maven-model</artifactId>
    </dependency>

That would translate to:

mvn(org.apache.maven:maven-model)
mvn(org.apache.maven:maven-plugin-api)
mvn(org.apache.maven:maven-core)
mvn(junit:junit)

Is the above and maven-local not sufficient?

Requires:   java-openjdk

I believe a java dependency will be auto-generated for you. No need to add this.

%files
%{_javadir}/%{name}
%{_javadocdir}/%{name}
%{_datadir}/maven-poms/%{name}
%{_datadir}/maven-metadata/%{name}.xml

Please use:

%files -f .mfiles

Regarding maven-javadoc-plugin BuildRequirement:

Consider using Xmvn's built-in mechanism. Soemthing like this should work:
https://src.fedoraproject.org/rpms/byteman/c/bfb4d668ca56d70d8aa76ae089ac686d72ba3b4c?branch=master

Thanks!

Comment 8 Severin Gehwolf 2018-11-16 09:15:28 UTC
Rawhide scratch build:
https://koji.fedoraproject.org/koji/taskinfo?taskID=30919012

Comment 9 Severin Gehwolf 2018-11-16 10:07:24 UTC
- Please use ASL 2.0 instead of ASL-2.0 in
  License field.
- Please remove '%global debug_package %{nil}'. The package is
  'BuildArch: noarch' and, thus, won't have debuginfo created.
  See: https://fedoraproject.org/wiki/Packaging:Debuginfo#Useless_or_incomplete_debuginfo_packages_due_to_packaging_issues


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)". Please use ASL 2.0 instead of ASL-2.0 in
     License field.
[?]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     directory-maven-plugin-javadoc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[?]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[?]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: directory-maven-plugin-0.3.1-1.fc28.noarch.rpm
          directory-maven-plugin-javadoc-0.3.1-1.fc28.noarch.rpm
          directory-maven-plugin-0.3.1-1.fc28.src.rpm
directory-maven-plugin.noarch: W: invalid-license ASL-2.0
directory-maven-plugin-javadoc.noarch: W: invalid-license ASL-2.0
directory-maven-plugin.src: W: invalid-license ASL-2.0
3 packages and 0 specfiles checked; 0 errors, 3 warnings.


Rpmlint (installed packages)
----------------------------
directory-maven-plugin-javadoc.noarch: W: invalid-license ASL-2.0
directory-maven-plugin-javadoc.noarch: W: invalid-url URL: https://github.com/jdcasey/directory-maven-plugin <urlopen error [Errno -2] Name or service not known>
directory-maven-plugin.noarch: W: invalid-license ASL-2.0
directory-maven-plugin.noarch: W: invalid-url URL: https://github.com/jdcasey/directory-maven-plugin <urlopen error [Errno -2] Name or service not known>
2 packages and 0 specfiles checked; 0 errors, 4 warnings.

Comment 11 Severin Gehwolf 2018-11-19 17:00:20 UTC
(In reply to Severin Gehwolf from comment #9)
> - Please use ASL 2.0 instead of ASL-2.0 in
>   License field.

Name:       directory-maven-plugin
Version:    0.3.1
Release:    1%{?dist}
Summary:    Establish locations for files in multi-module builds

License:    ASL-2.0

Looks like it's still "ASL-2.0" :-)

Comment 12 Severin Gehwolf 2018-11-20 09:36:56 UTC
Rawhide build:
https://koji.fedoraproject.org/koji/taskinfo?taskID=31014222

Comment 13 Severin Gehwolf 2018-11-20 09:42:43 UTC
Issues:

- Please use 'ASL 2.0' instead of 'ASL-2.0' in
  License field.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Package is
     ASL 2.0
[?]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     directory-maven-plugin-javadoc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[?]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[?]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: directory-maven-plugin-0.3.1-1.fc28.noarch.rpm
          directory-maven-plugin-javadoc-0.3.1-1.fc28.noarch.rpm
          directory-maven-plugin-0.3.1-1.fc28.src.rpm
directory-maven-plugin.noarch: W: invalid-license ASL-2.0
directory-maven-plugin-javadoc.noarch: W: invalid-license ASL-2.0
directory-maven-plugin.src: W: invalid-license ASL-2.0
3 packages and 0 specfiles checked; 0 errors, 3 warnings.



Rpmlint (installed packages)
----------------------------
directory-maven-plugin-javadoc.noarch: W: invalid-license ASL-2.0
directory-maven-plugin-javadoc.noarch: W: invalid-url URL: https://github.com/jdcasey/directory-maven-plugin <urlopen error [Errno -2] Name or service not known>
directory-maven-plugin.noarch: W: invalid-license ASL-2.0
directory-maven-plugin.noarch: W: invalid-url URL: https://github.com/jdcasey/directory-maven-plugin <urlopen error [Errno -2] Name or service not known>
2 packages and 0 specfiles checked; 0 errors, 4 warnings.

Comment 14 Severin Gehwolf 2018-11-20 09:43:33 UTC
APPROVED.

Please fix the 'ASL 2.0' vs. 'ASL-2.0' issue before you push.

Comment 16 Severin Gehwolf 2018-11-21 17:55:24 UTC
(In reply to Salman Siddiqui from comment #15)
> Updated.
> 
> License changed to 'ASL 2.0'.
> 
> SPEC URL:
> https://copr-be.cloud.fedoraproject.org/results/sasiddiq/jmc/fedora-29-
> x86_64/00827487-directory-maven-plugin/directory-maven-plugin.spec
> 
> SRPM URL:
> https://copr-be.cloud.fedoraproject.org/results/sasiddiq/jmc/fedora-29-
> x86_64/00827487-directory-maven-plugin/directory-maven-plugin-0.3.1-1.fc29.
> src.rpm

This has been approved already. Next step is to request the repository using 'fedpkg request-repo'

Comment 17 Gwyn Ciesla 2018-11-21 19:01:53 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/directory-maven-plugin


Note You need to log in before you can comment on or make changes to this bug.